/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of Parser.xs. Do not edit this file, edit Parser.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Parser.xs"
#/* Verilog.xs -- Verilog Booter  -*- C++ -*-
#*********************************************************************
#*
#* DESCRIPTION: Verilog::Parser Perl XS interface
#*
#* Author: Wilson Snyder <wsnyder@wsnyder.org>
#*
#* Code available from: http://www.veripool.org/
#*
#*********************************************************************
#*
#* Copyright 2000-2009 by Wilson Snyder.  This program is free software;
#* you can redistribute it and/or modify it under the terms of either the GNU
#* Lesser General Public License Version 3 or the Perl Artistic License Version 2.0.
#*
#* This program is distributed in the hope that it will be useful,
#* but WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU General Public License for more details.
#*
#* You should have received a copy of the Perl Artistic License
#* along with this module; see the file COPYING.  If not, see
#* www.cpan.org
#*
#***********************************************************************
#* Note with C++ XS libraries, the CLASS parameter is implied...
#***********************************************************************/

/* Mine: */
#include "VParse.h"
#include "VSymTable.h"
#include "VAst.h"

/* Perl */
extern "C" {
# include "EXTERN.h"
# include "perl.h"
# include "XSUB.h"
}

#ifdef open
# undef open	/* Perl 64 bit on solaris has a nasty hack that redefines open */
#endif

#//**********************************************************************
#// Parseressor derived classes, so we can override the callbacks to call perl.

class VParserXs : public VParse {
public:
    SV*		m_self;	// Class called from
    VFileLine*	m_cbFilelinep;	///< Last callback's starting point

    VFileLine* cbFilelinep() const { return m_cbFilelinep; }
    void cbFileline(const string& filename, int lineno) { m_cbFilelinep = m_cbFilelinep->create(filename, lineno); }
    void cbFileline(VFileLine* filelinep) { m_cbFilelinep = filelinep; }

    VParserXs(VFileLine* filelinep, av* symsp, bool sigparser, bool useUnreadbackFlag)
	: VParse(filelinep, symsp, sigparser, useUnreadbackFlag)
	  , m_cbFilelinep(filelinep)
	{}
    virtual ~VParserXs() {}

    // CALLBACKGEN_H_VIRTUAL
    // CALLBACKGEN_GENERATED_BEGIN - GENERATED AUTOMATICALLY by callbackgen
    // Verilog::Parser Callback methods
    virtual void attributeCb(VFileLine* fl, const string& text);
    virtual void commentCb(VFileLine* fl, const string& text);
    virtual void endparseCb(VFileLine* fl, const string& text);
    virtual void keywordCb(VFileLine* fl, const string& text);
    virtual void numberCb(VFileLine* fl, const string& text);
    virtual void operatorCb(VFileLine* fl, const string& text);
    virtual void preprocCb(VFileLine* fl, const string& text);
    virtual void stringCb(VFileLine* fl, const string& text);
    virtual void symbolCb(VFileLine* fl, const string& text);
    virtual void sysfuncCb(VFileLine* fl, const string& text);
    // Verilog::SigParser Callback methods
    virtual void endcellCb(VFileLine* fl, const string& kwd);
    virtual void endinterfaceCb(VFileLine* fl, const string& kwd);
    virtual void endmoduleCb(VFileLine* fl, const string& kwd);
    virtual void endpackageCb(VFileLine* fl, const string& kwd);
    virtual void endprogramCb(VFileLine* fl, const string& kwd);
    virtual void endtaskfuncCb(VFileLine* fl, const string& kwd);
    virtual void functionCb(VFileLine* fl, const string& kwd, const string& name, const string& data_type);
    virtual void importCb(VFileLine* fl, const string& package, const string& id);
    virtual void instantCb(VFileLine* fl, const string& mod, const string& cell, const string& range);
    virtual void interfaceCb(VFileLine* fl, const string& kwd, const string& name);
    virtual void moduleCb(VFileLine* fl, const string& kwd, const string& name, bool, bool celldefine);
    virtual void packageCb(VFileLine* fl, const string& kwd, const string& name);
    virtual void parampinCb(VFileLine* fl, const string& name, const string& conn, int index);
    virtual void pinCb(VFileLine* fl, const string& name, const string& conn, int index);
    virtual void portCb(VFileLine* fl, const string& name, const string& objof, const string& direction, const string& data_type
	, const string& array, int index);
    virtual void programCb(VFileLine* fl, const string& kwd, const string& name);
    virtual void taskCb(VFileLine* fl, const string& kwd, const string& name);
    virtual void varCb(VFileLine* fl, const string& kwd, const string& name, const string& objof, const string& net
	, const string& data_type, const string& array, const string& value);
    // CALLBACKGEN_GENERATED_END - GENERATED AUTOMATICALLY by callbackgen

    void call(string* rtnStrp, int params, const char* method, ...);
};

class VFileLineParseXs : public VFileLine {
    VParserXs*	m_vParserp;		// Parser handling the errors
public:
    VFileLineParseXs(int called_only_for_default) : VFileLine(called_only_for_default) {}
    virtual ~VFileLineParseXs() { }
    virtual VFileLine* create(const string filename, int lineno);
    virtual void error(const string msg);	// Report a error at given location
    void setParser(VParserXs* pp) { m_vParserp=pp; }
};

#//**********************************************************************
#// Overrides error handling virtual functions to invoke callbacks

VFileLine* VFileLineParseXs::create(const string filename, int lineno) {
    VFileLineParseXs* filelp = new VFileLineParseXs(true);
    filelp->init(filename, lineno);
    filelp->m_vParserp = m_vParserp;
    return filelp;
}

void VFileLineParseXs::error(string msg) {
    static string holdmsg; holdmsg = msg;
    m_vParserp->cbFileline(this);
    // Call always, not just if callbacks enabled
    m_vParserp->call(NULL, 1,"error",holdmsg.c_str());
}

#//**********************************************************************
#// Overrides of virtual functions to invoke callbacks

#include "Parser_callbackgen.cpp"

#//**********************************************************************
#// Manually created callbacks

#//**********************************************************************
#// General callback invoker

void VParserXs::call (
    string* rtnStrp,	/* If non-null, load return value here */
    int params,		/* Number of parameters */
    const char* method,	/* Name of method to call */
    ...)		/* Arguments to pass to method's @_ */
{
    // Call $perlself->method (passedparam1, parsedparam2)
    if (debug()) cout << "CALLBACK "<<method<<endl;
    va_list ap;
    va_start(ap, method);
    {
	dSP;				/* Initialize stack pointer */
	ENTER;				/* everything created after here */
	SAVETMPS;			/* ...is a temporary variable. */
	PUSHMARK(SP);			/* remember the stack pointer */
	XPUSHs(m_self);			/* $self-> */

	while (params--) {
	    char *text;
	    SV *sv;
	    text = va_arg(ap, char *);
	    if (text) {
		sv = newSVpv (text, 0);
	    } else {
		sv = &PL_sv_undef;
	    }
	    XPUSHs(sv);			/* token */
	}

	PUTBACK;			/* make local stack pointer global */

	if (rtnStrp) {
	    int rtnCount = perl_call_method ((char*)method, G_SCALAR);
	    SPAGAIN;			/* refresh stack pointer */
	    if (rtnCount > 0) {
		SV* sv = POPs;
		//printf("RTN %ld %d %s\n", SvTYPE(sv),SvTRUE(sv),SvPV_nolen(sv));
#ifdef SvPV_nolen	// Perl 5.6 and later
		*rtnStrp = SvPV_nolen(sv);
#else
		*rtnStrp = SvPV(sv,PL_na);
#endif
	    }
	    PUTBACK;
	} else {
	    perl_call_method ((char*)method, G_DISCARD | G_VOID);
	}

	FREETMPS;			/* free that return value */
	LEAVE;				/* ...and the XPUSHed "mortal" args.*/
    }
    va_end(ap);
}

#//**********************************************************************

#line 206 "Parser.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 258 "Parser.c"

XS(XS_Verilog__Parser__new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser__new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "CLASS, SELF, symsp, sigparser, useUnreadback");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0));
	VParserXs *	RETVAL;
	SV*	SELF = ST(1);
	AV*	symsp;
	bool	sigparser = (bool)SvTRUE(ST(3));
	bool	useUnreadback = (bool)SvTRUE(ST(4));

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    symsp = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Verilog::Parser::_new",
				"symsp");
		}
	} STMT_END;
#line 205 "Parser.xs"
{
    if (CLASS) {}  /* Prevent unused warning */
    VFileLineParseXs* filelinep = new VFileLineParseXs(1/*ok,for initial*/);
    VParserXs* parserp = new VParserXs(filelinep, symsp, sigparser, useUnreadback);
    filelinep->setParser(parserp);
    parserp->m_self = newSVsv(SELF);
    RETVAL = parserp;
}
#line 299 "Parser.c"
	ST(0) = sv_newmortal();
    // SELF->{_cthis} = THIS
    if( sv_isobject(SELF) && (SvTYPE(SvRV(SELF)) == SVt_PVHV) ) {
	SV **svp = hv_fetch ((HV*)SvRV(SELF), "_cthis", 6, 1);
	sv_setiv(*svp, PTR2IV( RETVAL ));
	XSRETURN_UNDEF;
    } else {
        warn( "Verilog::Parser::_new() -- RETVAL is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    }

    }
    XSRETURN(1);
}


XS(XS_Verilog__Parser__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser__DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::_DESTROY() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
#line 222 "Parser.xs"
{
    delete THIS;
}
#line 341 "Parser.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Parser__debug); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser__debug)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "THIS, level");
    {
	int	level = (int)SvIV(ST(1));
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::_debug() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
#line 234 "Parser.xs"
{
    THIS->debug(level);
    VAstEnt::debug(level);
}
#line 374 "Parser.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Parser__callback_enable); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser__callback_enable)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "THIS, flag");
    {
	bool	flag = (bool)SvTRUE(ST(1));
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::_callback_enable() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
#line 248 "Parser.xs"
{
    THIS->callbackEnable(flag);
}
#line 406 "Parser.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Parser_eof); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser_eof)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::eof() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
#line 259 "Parser.xs"
{
    THIS->setEof();
}
#line 437 "Parser.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Parser_filename); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser_filename)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, flagp=\"\"");
    {
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::filename() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
	const char *	RETVAL;
	dXSTARG;
	const char*	flagp;

	if (items < 2)
	    flagp = "";
	else {
	    flagp = (const char *)SvPV_nolen(ST(1));
	}
#line 269 "Parser.xs"
{
    if (!THIS) XSRETURN_UNDEF;
    if (items > 1) {
	THIS->inFileline(flagp, THIS->inFilelinep()->lineno());
	THIS->cbFileline(flagp, THIS->inFilelinep()->lineno());
    }
    RETVAL = THIS->cbFilelinep()->filename().c_str();
}
#line 482 "Parser.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Verilog__Parser_language); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser_language)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "THIS, valuep");
    {
	const char*	valuep = (const char *)SvPV_nolen(ST(1));
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::language() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
#line 287 "Parser.xs"
{
    if (items > 1) {
        THIS->language(valuep);
    }
}
#line 517 "Parser.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Parser_lineno); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser_lineno)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, flag=0");
    {
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::lineno() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
	int	RETVAL;
	dXSTARG;
	int	flag;

	if (items < 2)
	    flag = 0;
	else {
	    flag = (int)SvIV(ST(1));
	}
#line 300 "Parser.xs"
{
    if (!THIS) XSRETURN_UNDEF;
    if (items > 1) {
	THIS->inFileline(THIS->inFilelinep()->filename(), flag);
	THIS->cbFileline(THIS->inFilelinep()->filename(), flag);
    }
    RETVAL = (THIS->cbFilelinep()->lineno());
}
#line 562 "Parser.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Verilog__Parser_parse); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser_parse)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "THIS, textp");
    {
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::parse() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
	const char*	textp = (const char *)SvPV_nolen(ST(1));
#line 317 "Parser.xs"
{
    THIS->parse(textp);
}
#line 595 "Parser.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Parser_selftest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser_selftest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::selftest() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
#line 328 "Parser.xs"
{
    VSymStack::selftest();
}
#line 626 "Parser.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Parser_unreadback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser_unreadback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, flagp=\"\"");
    {
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::unreadback() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
	SV *	RETVAL;
	const char*	flagp;

	if (items < 2)
	    flagp = "";
	else {
	    flagp = (const char *)SvPV_nolen(ST(1));
	}
#line 339 "Parser.xs"
{
    if (!THIS) XSRETURN_UNDEF;
    // Set RETVAL to a SV before we replace with the new value, and c_str may change
    RETVAL = newSVpv(THIS->unreadback().c_str(), THIS->unreadback().length());
    if (items > 1) {
	THIS->unreadback(flagp);
    }
}
#line 670 "Parser.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Verilog__Parser_unreadbackCat); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Parser_unreadbackCat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "THIS, textsvp");
    {
	VParserXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VParserXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VParserXs*>(THIS)) {
        warn( "Verilog::Parser::unreadbackCat() -- THIS is not a Verilog::Parser object" );
        XSRETURN_UNDEF;
    };
	SV*	textsvp = ST(1);
#line 356 "Parser.xs"
{
    if (!THIS) XSRETURN_UNDEF;
    STRLEN textlen;
    const char* textp = SvPV(textsvp, textlen);
    THIS->unreadbackCat(textp, textlen);
}
#line 707 "Parser.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Verilog__Parser); /* prototype to pass -Wmissing-prototypes */
XS(boot_Verilog__Parser)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("Verilog::Parser::_new", XS_Verilog__Parser__new, file, "$$$$");
        (void)newXSproto_portable("Verilog::Parser::_DESTROY", XS_Verilog__Parser__DESTROY, file, "$");
        (void)newXSproto_portable("Verilog::Parser::_debug", XS_Verilog__Parser__debug, file, "$$");
        (void)newXSproto_portable("Verilog::Parser::_callback_enable", XS_Verilog__Parser__callback_enable, file, "$$");
        (void)newXSproto_portable("Verilog::Parser::eof", XS_Verilog__Parser_eof, file, "$");
        (void)newXSproto_portable("Verilog::Parser::filename", XS_Verilog__Parser_filename, file, "$;$");
        (void)newXSproto_portable("Verilog::Parser::language", XS_Verilog__Parser_language, file, "$$");
        (void)newXSproto_portable("Verilog::Parser::lineno", XS_Verilog__Parser_lineno, file, "$;$");
        (void)newXSproto_portable("Verilog::Parser::parse", XS_Verilog__Parser_parse, file, "$$");
        (void)newXSproto_portable("Verilog::Parser::selftest", XS_Verilog__Parser_selftest, file, "$");
        (void)newXSproto_portable("Verilog::Parser::unreadback", XS_Verilog__Parser_unreadback, file, "$;$");
        (void)newXSproto_portable("Verilog::Parser::unreadbackCat", XS_Verilog__Parser_unreadbackCat, file, "$$");
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

